<template>
	<div class="d-inline-flex">
		<v-btn class="px-4" icon @click="showConfirmationDialog = true" v-bind="$attrs">
			<v-icon>mdi-delete</v-icon>
		</v-btn>

		<confirm-dialog
			v-model="showConfirmationDialog"
			title="Revoke API Key"
			:error="hasError ? error : undefined"
			:loading="isLoading"
			button="Revoke Key"
			button-color="error"
			persistent
			@cleanup="clearError"
			@confirm="handleConfirmRevoke"
		>
			<p class="mt-0 mb-4">
				Are you sure you want to revoke the API key:
				<code>{{ apiKey.label }}</code
				>?
			</p>
			<ul>
				<li>Revoking an API key is irreversible: you will be unable to recover the API key once it is revoked.</li>
				<li>Any applications using the API key will no longer have access to SoilStack.</li>
				<li>If you believe your API key has been compromised, you should revoke it and generate a new one.</li>
			</ul>
		</confirm-dialog>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import { useRevokeApiKey } from '@/store/modules/apiKeys';
import { ApiKey } from '@/store/types';

export default defineComponent({
	components: { ConfirmDialog },
	inheritAttrs: false,
	props: {
		apiKey: {
			type: Object as () => ApiKey,
			required: true,
		},
	},
	setup(props, { root }) {
		const showConfirmationDialog = ref<boolean>(false);
		const { revokeApiKey, clearError, isLoading, hasError, error: revokeError } = useRevokeApiKey(root.$store);

		const error = computed<string>(
			() =>
				revokeError.value?.response?.data?.message ||
				'An error occurred while attempting to revoke the API key. Please try again.'
		);

		const handleConfirmRevoke = async () => {
			clearError();

			const success = await revokeApiKey(props.apiKey.id);

			if (success) {
				root.$store.dispatch('user/getUser');
				showConfirmationDialog.value = false;
			}
		};

		return {
			showConfirmationDialog,
			handleConfirmRevoke,
			clearError,
			isLoading,
			hasError,
			error,
		};
	},
});
</script>
